/*========================================================================
    Copyright (C) 1999  Ing Krippel Harald
    E-Mail: neuro.harald@surfeu.at

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

========================================================================*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <OS.h>

#include "evolut.h"

long 	lernmust = ANFMUST;			// mit x mustern beginnen
double	STOPERROR = ANFERR;		// 0.0165

// Gehirngröße
long 	NEURONANZ=0;
int	MAXINP;
int	MAXHINEU;
int	MAXSCHICHT;
int	MAXOUT;
/* Grenzwerte fr Skalierung */

float iskalmin;
float iskalmax;
float oskalmin;
float oskalmax;

long	LERNMUSTMAX;
long	TESTMUSTMAX;

long 	komb =2;		// 	0 ist mutter oder fater , 1 ist kind ist mutter+fater /2	3 RND Schneidestelle
long	eltaus = 0; // 0 der beste ist Fater ; 1 jeder mit jedem Zufall ; 2 Roulet Weehl	2
long	type	= 0;	// 0 nur forwrtsverbindungen ; 1 mit forwrts berspringen ; 2 mit Rckverbindungen
long	iterat = 2;	// Bei Type 2 anzahl der Iterationen bis Out des Netzes gelesen

/* Defines fr Dialog */


// ------------------------------------------------------------------------------------------------
// Deklaration der globalen Variablen.
// ------------------------------------------------------------------------------------------------

//POPULATION	mypop;
long aa=0;
long bb=0;
long cc=0;
long dd=0;
float *daten;
long start = -1;
//long LERNMUSTMAX;


// ------------------------------------------------------------------------------------------------
// Forward-Declarations.
// ------------------------------------------------------------------------------------------------


void save_daten(CHROM *cromo,char *name)
{
	long k,j,err;
	FILE *fp;


	if((fp=fopen(name,"w"))==NULL)
	{
		fprintf(stderr,"%s : File Open Error !!\n",name);
		exit(-1);
	}

	err=fprintf(fp,"%d %d %d %d %f %f %f %f\n",MAXINP,MAXHINEU,MAXSCHICHT,MAXOUT,iskalmin,iskalmax,oskalmin,oskalmax);
				// Neuronen
		for(j=0; j < NEURONANZ ; j++)
		{
			err=fprintf(fp,"%f %f %f %f\n",cromo->myrep->Neuronen[j].aktiv,
											cromo->myrep->Neuronen[j].offset,
											cromo->myrep->Neuronen[j].temp,
											cromo->myrep->Neuronen[j].output);
		}
	
			/* Speichere Gewichte */
 	 	  for(k=0;k<NEURONANZ;k++)
		  {
			for(j=0;j<NEURONANZ;j++)
			{
				if(k>=MAXINP)
				{
					err=fprintf(fp,"%f\n",cromo->myrep->gewicht[k*NEURONANZ+j]);
				}
			}
		 }
	fclose(fp);
}
void open_daten(char *name)
{
	long k,j,err,testinp,testhineu,testmaxschicht,testmaxout;
	FILE *fp;
	CHROM		*cromo;

	cromo = mypop.rep;

	if((fp=fopen(name,"r"))==NULL)
	{
		fprintf(stderr,"%s : File Open Error !!\n",name);
		exit(-1);
	}

	err=fscanf(fp,"%ld %ld %ld %ld\n",&testinp,&testhineu,&testmaxschicht,&testmaxout);
	if(testinp != MAXINP || testhineu != MAXHINEU || testmaxschicht != MAXSCHICHT || testmaxout != MAXOUT)
	{
		fprintf(stderr,"Strukturen nicht gleich!!\n");
		exit(-1);
	}
	NEURONANZ=MAXINP+MAXHINEU*MAXSCHICHT+MAXOUT;
				// Neuronen
		for(j=0; j < NEURONANZ ; j++)
		{
			err=fscanf(fp,"%f %lf %lf %lf\n",&cromo->myrep->Neuronen[j].aktiv,
											&cromo->myrep->Neuronen[j].offset,
											&cromo->myrep->Neuronen[j].temp,
											&cromo->myrep->Neuronen[j].output);
		}
	
			/* Speichere Gewichte */
 	 	  for(k=0;k<NEURONANZ;k++)
		  {
			for(j=0;j<NEURONANZ;j++)
			{
				if(k>=MAXINP)
				{
					err=fscanf(fp,"%lf\n",&cromo->myrep->gewicht[k*NEURONANZ+j]);
				}
			}
		 }
	fclose(fp);
}

void save_all_data(POPULATION	*mypop,char *name)
{
	long k,j,l,err;
	FILE *fp;
	CHROM		*cromo;


	if((fp=fopen(name,"w"))==NULL)
	{
		fprintf(stderr,"%s : File Open Error !!\n",name);
		exit(-1);
	}

	err=fprintf(fp,"%d %d %d %d %d %d %f\n",MAXINP,MAXHINEU,MAXSCHICHT,MAXOUT,mypop->generation,lernmust,STOPERROR);
	for(l=0;l<mypop->size;l++)
	{
		cromo = &mypop->rep[l];
		
		err=fprintf(fp,"%d %d\n",cromo->mutprob,
								cromo->mutdim);
				// Neuronen
		for(j=0; j < NEURONANZ ; j++)
		{
			err=fprintf(fp,"%f %f %f %f\n",cromo->myrep->Neuronen[j].aktiv,
											cromo->myrep->Neuronen[j].offset,
											cromo->myrep->Neuronen[j].temp,
											cromo->myrep->Neuronen[j].output);
		}
	
			/* Speichere Gewichte */
 	 	  for(k=0;k<NEURONANZ;k++)
		  {
			for(j=0;j<NEURONANZ;j++)
			{
				if(k>=MAXINP)
				{
					err=fprintf(fp,"%f\n",cromo->myrep->gewicht[k*NEURONANZ+j]);
				}
			}
		 }
	}
	fclose(fp);
}

void open_alldata(POPULATION	*mypop,char *name)
{
	long k,j,l,err,testinp,testhineu,testmaxschicht,testmaxout;
	FILE *fp;
	CHROM		*cromo;


	if((fp=fopen(name,"r"))==NULL)
	{
		fprintf(stderr,"%s : File Open Error !!\n",name);
		exit(-1);
	}


	err=fscanf(fp,"%ld %ld %ld %ld %ld %ld %lf\n",&testinp,&testhineu,&testmaxschicht,&testmaxout,&mypop->generation,&lernmust,&STOPERROR);
	if(testinp != MAXINP || testhineu != MAXHINEU || testmaxschicht != MAXSCHICHT || testmaxout != MAXOUT)
	{
		fprintf(stderr,"Strukturen nicht gleich!!\n");
		exit(-1);
	}
	
	for(l=0;l<mypop->size;l++)
	{
		cromo = &mypop->rep[l];
		
		err=fscanf(fp,"%d %d\n",&cromo->mutprob,
								&cromo->mutdim);

				// Neuronen
		for(j=0; j < NEURONANZ ; j++)
		{
			err=fscanf(fp,"%f %lf %lf %lf\n",&cromo->myrep->Neuronen[j].aktiv,
											&cromo->myrep->Neuronen[j].offset,
											&cromo->myrep->Neuronen[j].temp,
											&cromo->myrep->Neuronen[j].output);
		}
	
			/* Speichere Gewichte */
 	 	for(k=0;k<NEURONANZ;k++)
		{
			for(j=0;j<NEURONANZ;j++)
			{
				if(k>=MAXINP)
				{
					err=fscanf(fp,"%lf\n",&cromo->myrep->gewicht[k*NEURONANZ+j]);
				}
			}
		}
	}
	fclose(fp);
}

/*---------------------------------------------------------------------------------*/
void lade_daten(char *name)
{
	long i,j,err;
	FILE *fp;

	if((fp=fopen(name,"r"))==NULL)
	{
		fprintf(stderr,"%s : File Open Error !!\n",name);
		exit(-1);
	}
	i=0;
	err=0;
	err=fscanf(fp,"%d %d %d %d %f %f %f %f %ld %ld\n",&MAXINP,&MAXHINEU,&MAXSCHICHT,&MAXOUT,
											&iskalmin,&iskalmax,&oskalmin,&oskalmax,
											&LERNMUSTMAX,&TESTMUSTMAX);

	NEURONANZ=MAXINP+MAXHINEU*MAXSCHICHT+MAXOUT;
	daten= (float *) malloc(1000*(MAXINP+MAXOUT)*sizeof(float));


	do
	{
		for(j=0;j<(MAXINP+MAXOUT);j++)
		{
			err=fscanf(fp,"%f",&daten[i*(MAXINP+MAXOUT)+j]);
		}
		i++;
	}
	while(err != EOF);

//	LERNMUSTMAX =  i - TESTMUSTMAX;

	fclose(fp);
}

/*---------------------------------------------------------------------------------*/
void init_muster(POPULATION *pop)
{
	long i,j;

	/* Lerndaten Initialisieren */

	for(i=0; i<LERNMUSTMAX ;i++) /* Eingangsdaten laut File setzen */
	{
		for(j=0;j<(MAXINP);j++)
		{
			pop->musterI[i][j]= do_skal(iskalmin,iskalmax,daten[i*(MAXINP+MAXOUT)+j]);
		}
	}

	for(i=0; i<LERNMUSTMAX ;i++) /* Ausgangsdaten laut File setzen */
	{
		for(j=0;j<(MAXOUT);j++)
		{
			pop->musterO[i][j]= do_skal(oskalmin,oskalmax,daten[i*(MAXINP+MAXOUT)+j+MAXINP]);
		}
	}

	/* Testdaten Initialisieren */
	for(i=LERNMUSTMAX; i < LERNMUSTMAX + TESTMUSTMAX;i++)
	{
		for(j=0;j<(MAXINP);j++)
		{
			pop->musterI[i][j]= do_skal(iskalmin,iskalmax,daten[i*(MAXINP+MAXOUT)+j]);
		}
	}

	for(i=LERNMUSTMAX; i < LERNMUSTMAX + TESTMUSTMAX;i++)
	{
		for(j=0;j<(MAXOUT);j++)
		{
			pop->musterO[i][j]= do_skal(oskalmin,oskalmax,daten[i*(MAXINP+MAXOUT)+j+MAXINP]);
		}
	}

}
/*---------------------------------------------------------------------------------*/
long Do_Evolution(POPULATION *pop)
{
	long error;

	if(pop->inUse == TRUE)
	{
		if(pop->InitOK == FALSE)
		{
			error = PopAlloc(pop);		// Population Speicher anfordern
			if(!error)
					{
					printf("Zuwenig Speicher !");
					exit(-1);
					}
			error = PopInit(pop);	// Population mit Startwerten versehen
			 error = Do_Qualitat(pop);	// Qualitt der Spieler ermitteln
			error = Qualitatsauswahl(pop);	// Die Alten sterben und nur die Besten kommen durch
			error = Do_Print(pop);		// Daten der Population anzeigen
			pop->InitOK = TRUE;
			pop->generation = 0;
		}
		else
		{
			if(pop->inPause == FALSE)
				{
					switch(bb)
					{
					case 0:
						error = Do_NeueKinder(pop);	// Zeuge neue Kinder
						break;
					case 1:
						error = Do_PopMut(pop);		// Mutiere die gesammte population Gleichverteilter Zufall
						break;	
					case 2:
						error = Do_Qualitat(pop);	// Qualitt der Spieler ermitteln
						break;
					case 3:
						error = Qualitatsauswahl(pop);	// Die Alten sterben und nur die Besten kommen durch
						break;
					case 4:
						error = Do_Print(pop);		// Daten der Population anzeigen
						pop->generation++;
						if(pop->generation > pop->maxgenera)
							pop->inPause =	TRUE;
						bb = -1;
						break;
					}
				bb++;
				}
		}
	}

//	PopFree(pop);				// Population wieder freigeben
return(1);
}

/*---------------------------------------------------------------------------------*/
long PopAlloc(POPULATION *pop)
{
	long	i;
	CHROM		*cromo;

	pop->fitvec = (double *) malloc(pop->size * sizeof(double));
	if(!pop->fitvec)
		return(0);

	pop->rep = (CHROM *) malloc(pop->size * sizeof(CHROM));
	if(!pop->rep)
			return(0);

	cromo = pop->rep;
	for(i=0; i < pop->size ; i++)
	{
		cromo->myrep = (GEHIRN *) malloc( sizeof(GEHIRN));
		if(!cromo->myrep)
				return(0);
		cromo->myrep->Neuronen=(NEURON *) malloc( NEURONANZ*sizeof(NEURON));
		if(!cromo->myrep->Neuronen)
				return(0);
		cromo->myrep->gewicht= (double *) malloc(NEURONANZ*NEURONANZ*sizeof(double));
		if(!cromo->myrep->gewicht)
				return(0);
		cromo++;
	}
			  // fr Back
	pop->back = (CHROM *) malloc(pop->size * sizeof(CHROM));
	if(!pop->back)
			return(0);

	cromo = pop->back;
	for(i=0; i < pop->size ; i++)
	{
		cromo->myrep = (GEHIRN *) malloc( sizeof(GEHIRN));
		if(!cromo->myrep)
				return(0);
		cromo->myrep->Neuronen=(NEURON *) malloc( NEURONANZ*sizeof(NEURON));
		if(!cromo->myrep->Neuronen)
				return(0);		
		cromo->myrep->gewicht= (double *) malloc(NEURONANZ*NEURONANZ*sizeof(double));
		if(!cromo->myrep->gewicht)
				return(0);
		cromo++;
	}

return(1);	// alles OK
}
/*---------------------------------------------------------------------------------*/
long PopInit(POPULATION *pop)
{
	long	i,j,k,s;
	CHROM		*cromo;

cromo = pop->rep;
	for(i=0; i < pop->size ; i++)
	{
		cromo->mutprob =50;		// 4    jedes n te Lebewesen wird mutiert
		cromo->mutdim = 100;		// 10    jedes n te Gewicht wird mutiert
		cromo->mutdimN = 100;	// 10       jedes n te Neuron Aktivitt
		cromo->mutdimV = 100;	// 10
		cromo->mutdimT = 100;	// 10
//		cromo->mutprob =(int)((double)rand()/RAND_MAX*((30)-(8))+(8));
//		cromo->mutdim = (int)((double)rand()/RAND_MAX*((30)-(8))+(8));
//		cromo->mutproz = ((double)rand()/RAND_MAX*((0.2)-(0.2))+(0.2));	// 0.5 bis 0.2
//		cromo->mutprozN = ((double)rand()/RAND_MAX*((0.2)-(0.2))+(0.2));	// 0.5 bis 0.2
//		cromo->mutprozT = ((double)rand()/RAND_MAX*((0.2)-(0.2))+(0.2));	// 0.5 bis 0.2
//		cromo->mutprozV = ((double)rand()/RAND_MAX*((0.2)-(0.2))+(0.2));	// 0.5 bis 0.2

		cromo->mutproz = 0.5;	// 0,008
		cromo->mutprozN = 0.5;	// 0.01
		cromo->mutprozT = 0.5;	// 0.01
		cromo->mutprozV = 0.5;	// 0.01

		cromo->fitness = 0;
		cromo->gerechnet=0;

				// init Gewichte
  		 for(k=0;k<NEURONANZ;k++)
 		 {
			for(j=0;j<NEURONANZ;j++)
			{
 				cromo->myrep->gewicht[k*NEURONANZ+j]=0;
  		    }		 
 		 }
  
  
		if(type == 0)
		{
			// Inputbereich
		  for(k=MAXINP;k<MAXINP+MAXHINEU;k++)
		  {
			for(j=0;j<MAXINP;j++)
			{
				cromo->myrep->gewicht[k*NEURONANZ+j]=((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
			}
  		  }
  		  	// fr Zwischenschichten
		  for(s=0;s<MAXSCHICHT-1;s++)
		  {
			  for(k=MAXINP+MAXHINEU*(s+1);k<MAXINP+MAXHINEU*(s+2);k++)
			  {
				for(j=MAXINP+MAXHINEU*(s);j<MAXINP+MAXHINEU*(s+1);j++)
				{
					cromo->myrep->gewicht[k*NEURONANZ+j]=((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
				}
  			  }
  		  }
  		  
  		  	// fr Outputbereich		 
		  for(k=NEURONANZ-MAXOUT;k<NEURONANZ;k++)
		  {
			for(j=MAXINP+MAXHINEU*(MAXSCHICHT-1);j<NEURONANZ-MAXOUT;j++)
			{
				cromo->myrep->gewicht[k*NEURONANZ+j]=((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
			}
  		  }
 		}

		if(type == 1)
		{
			// Inputbereich
		  for(k=MAXINP;k<MAXINP+MAXHINEU;k++)
		  {
			for(j=0;j<MAXINP;j++)
			{
				cromo->myrep->gewicht[k*NEURONANZ+j]=((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
			}
  		  }
  		  	// fr Zwischenschichten
		  for(s=0;s<MAXSCHICHT-1;s++)
		  {
			  for(k=MAXINP+MAXHINEU*(s+1);k<MAXINP+MAXHINEU*(s+2);k++)
			  {
				for(j=0;j<MAXINP+MAXHINEU*(s+1);j++)
				{
					cromo->myrep->gewicht[k*NEURONANZ+j]=((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
				}
  			  }
  		  }
  		  
  		  	// fr Outputbereich		 
		  for(k=NEURONANZ-MAXOUT;k<NEURONANZ;k++)
		  {
			for(j=0;j<NEURONANZ-MAXOUT;j++)
			{
				cromo->myrep->gewicht[k*NEURONANZ+j]=((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
			}
  		  }
 		}
		if(type == 2)
		{
 	 	  for(k=0;k<NEURONANZ;k++)
		  {
			for(j=0;j<NEURONANZ;j++)
			{
			if(k>=MAXINP)
			{
				cromo->myrep->gewicht[k*NEURONANZ+j]=((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
 			}
 			else
 		   {
 				cromo->myrep->gewicht[k*NEURONANZ+j]=0;
		   }
			}
  		  }
 		}
				// Neuronen
		for(j=0; j < NEURONANZ ; j++)
		{
			if((j>=MAXINP) && (j<NEURONANZ-MAXOUT))
			{
				cromo->myrep->Neuronen[j].aktiv = ((double)rand()/RAND_MAX*((0.02)-(-0.02))+(-0.02));
	//			cromo->myrep->Neuronen[j].aktiv = 0.08;		// alle Aktiv
			}
			else
			{
				cromo->myrep->Neuronen[j].aktiv = 1;
			}
			cromo->myrep->Neuronen[j].offset = ((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
			cromo->myrep->Neuronen[j].temp = ((double)rand()/RAND_MAX*((0.8)-(0.8))+(0.8));
			cromo->myrep->Neuronen[j].output = 0;
		}
		cromo++;
	}
return(1);	// alles OK
}
/*---------------------------------------------------------------------------------*/
long Do_PopMut(POPULATION *pop)
{
	long	i,j,k,s;
	CHROM		*cromo;

	cromo = pop->rep;
	for(i=0; i < pop->size ; i++)	// von 1 bis letzten Lebewesen
	{
		if( 1==(long)((double)rand()/RAND_MAX*(cromo->mutprob)))
  		{
			cromo->gerechnet=0;
		 if( 1==(long)((double)rand()/RAND_MAX*(10)))
		 {
			cromo->mutprob += (long)((double)rand()/RAND_MAX*((2)-(-2))+(-2));
			if(cromo->mutprob < 2)
				cromo->mutprob = 2;
		 }
		 if( 1==(long)((double)rand()/RAND_MAX*(10)))	//10
		 {
			cromo->mutdim +=(long) ((double)rand()/RAND_MAX*((2)-(-2))+(-2)+0.5);
			if(cromo->mutdim < 2)
				cromo->mutdim = 2;
		 }
		cromo->mutdimN=cromo->mutdimV=cromo->mutdimT=cromo->mutdim;
//		 if( 1==(long)((double)rand()/RAND_MAX*(cromo->mutdimN)))
//		 {
//			cromo->mutdimN +=(long) ((double)rand()/RAND_MAX*((mutmax)-(mutmin))+(mutmin)+0.5);
//			if(cromo->mutdimN < 2)
//				cromo->mutdimN = 2;
//		 }

//		 if( 1==(long)((double)rand()/RAND_MAX*(cromo->mutdimV)))
//		 {
//			cromo->mutdimV +=(long) ((double)rand()/RAND_MAX*((mutmax)-(mutmin))+(mutmin)+0.5);
//			if(cromo->mutdimV < 2)
//				cromo->mutdimV = 2;
//		 }

//		 if( 1==(long)((double)rand()/RAND_MAX*(cromo->mutdimT)))
//		 {
//			cromo->mutdimT +=(long) ((double)rand()/RAND_MAX*((mutmax)-(mutmin))+(mutmin)+0.5);
//			if(cromo->mutdimT < 2)
//				cromo->mutdimT = 2;
//		 }
//		 if( 1==(long)((double)rand()/RAND_MAX*(cromo->mutdim)))
//			cromo->mutproz += 0.00001+cromo->mutproz*((double)rand()/RAND_MAX*((mutmax)-(mutmin))+(mutmin));	// 1,-1

//		 if( 1==(long)((double)rand()/RAND_MAX*(cromo->mutdimT)))
//			cromo->mutprozT += 0.00001+cromo->mutprozT*((double)rand()/RAND_MAX*((mutmax)-(mutmin))+(mutmin));	// 1,-1

//		 if( 1==(long)((double)rand()/RAND_MAX*(cromo->mutdimN)))
//			cromo->mutprozN += 0.00001+cromo->mutprozN*((double)rand()/RAND_MAX*((mutmax)-(mutmin))+(mutmin));	// 1,-1

//		 if( 1==(long)((double)rand()/RAND_MAX*(cromo->mutdimV)))
//			cromo->mutprozV += 0.00001+cromo->mutprozV*((double)rand()/RAND_MAX*((mutmax)-(mutmin))+(mutmin));	// 1,-1

				// init Gewichte
		if(type == 0)
		{
			// Inputbereich
		  for(k=MAXINP;k<MAXINP+MAXHINEU;k++)
		  {
			for(j=0;j<MAXINP;j++)
			{
			 if( 1 == (long)((double)rand()/RAND_MAX*(cromo->mutdim)))
			 {
				cromo->myrep->gewicht[k*NEURONANZ+j]+=cromo->mutproz*((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
			 }
			}
  		  }
  		  	// fr Zwischenschichten
		  for(s=0;s<MAXSCHICHT-1;s++)
		  {
			  for(k=MAXINP+MAXHINEU*(s+1);k<MAXINP+MAXHINEU*(s+2);k++)
			  {
				for(j=MAXINP+MAXHINEU*(s);j<MAXINP+MAXHINEU*(s+1);j++)
				{
			 		if( 1 == (long)((double)rand()/RAND_MAX*(cromo->mutdim)))
			 		{
						cromo->myrep->gewicht[k*NEURONANZ+j]+=cromo->mutproz*((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
					}
				}
  			  }
  		  }
  		  
  		  	// fr Outputbereich		 
		  for(k=NEURONANZ-MAXOUT;k<NEURONANZ;k++)
		  {
			for(j=MAXINP+MAXHINEU*(MAXSCHICHT-1);j<NEURONANZ-MAXOUT;j++)
			{
			 	if( 1 == (long)((double)rand()/RAND_MAX*(cromo->mutdim)))
			 	{
					cromo->myrep->gewicht[k*NEURONANZ+j]+=cromo->mutproz*((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
				}
			}
  		  }
 		}

		if(type == 1)
		{
			// Inputbereich
		  for(k=MAXINP;k<MAXINP+MAXHINEU;k++)
		  {
			for(j=0;j<MAXINP;j++)
			{
			 	if( 1 == (long)((double)rand()/RAND_MAX*(cromo->mutdim)))
			 	{
					cromo->myrep->gewicht[k*NEURONANZ+j]+=cromo->mutproz*((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
				}
			}
  		  }
  		  	// fr Zwischenschichten
		  for(s=0;s<MAXSCHICHT-1;s++)
		  {
			  for(k=MAXINP+MAXHINEU*(s+1);k<MAXINP+MAXHINEU*(s+2);k++)
			  {
				for(j=0;j<MAXINP+MAXHINEU*(s+1);j++)
				{
			 		if( 1 == (long)((double)rand()/RAND_MAX*(cromo->mutdim)))
			 		{
						cromo->myrep->gewicht[k*NEURONANZ+j]+=cromo->mutproz*((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
					}
				}
  			  }
  		  }
  		  
  		  	// fr Outputbereich		 
		  for(k=NEURONANZ-MAXOUT;k<NEURONANZ;k++)
		  {
			for(j=0;j<NEURONANZ-MAXOUT;j++)
			{
			 	if( 1 == (long)((double)rand()/RAND_MAX*(cromo->mutdim)))
			 	{
					cromo->myrep->gewicht[k*NEURONANZ+j]+=cromo->mutproz*((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
				}
			}
  		  }
 		}
		if(type == 2)
		{
 	 	  for(k=0;k<NEURONANZ;k++)
		  {
			for(j=0;j<NEURONANZ;j++)
			{
			if(k>=MAXINP)
			{
			 	if( 1 == (long)((double)rand()/RAND_MAX*(cromo->mutdim)))
			 	{
					cromo->myrep->gewicht[k*NEURONANZ+j]+=cromo->mutproz*((double)rand()/RAND_MAX*((Wgmax)-(Wgmin))+Wgmin);
				}
 			}
 			else
 		   {
 				cromo->myrep->gewicht[k*NEURONANZ+j]=0;
		   }
			}
  		  }
 		}


				// Neuronen
		for(j=0; j < NEURONANZ ; j++)
		{
		 if( 1==(long)((double)rand()/RAND_MAX*(cromo->mutdimN)))
					cromo->myrep->Neuronen[j].aktiv += cromo->mutprozN* ((double)rand()/RAND_MAX*((mutmax)-(mutmin))+(mutmin));
		 if( 1==(long)((double)rand()/RAND_MAX*(cromo->mutdim)))
					cromo->myrep->Neuronen[j].offset += cromo->mutproz* ((double)rand()/RAND_MAX*((Wmax)-(Wmin))+(Wmin));
		 if( 1==(long)((double)rand()/RAND_MAX*(cromo->mutdimT)))
					cromo->myrep->Neuronen[j].temp += cromo->mutprozT* ((double)rand()/RAND_MAX*((mutmax)-(mutmin))+(mutmin));
		 if(cromo->myrep->Neuronen[j].temp < 0)
			cromo->myrep->Neuronen[j].temp = 0;
		 if(cromo->myrep->Neuronen[j].temp > 1)
			cromo->myrep->Neuronen[j].temp = 1;
		}
	}
	cromo++;
 }
return(1);	// alles OK
}
/*---------------------------------------------------------------------------------*/
long Do_NeueKinder(POPULATION *pop)
{
	CHROM	*Mutter;
	CHROM	*Vater;
	CHROM	*Kind;

	long indexv,indexm,i,k;
	double	summe,gsumme,minfit;
	double	zufall;

	Vater = pop->rep;
	Mutter = pop->rep;
	Kind = pop->back;
	minfit=pop->rep[0].fitness;
	for(i=0;i<pop->nbest;i++)
	{
		if(komb==0)
			do_rekomb(&Vater[i], &Vater[i], &Kind[i]);
		if(komb==1)
			do_rekomb1(&Vater[i], &Vater[i], &Kind[i]);
		if(komb==2)
			do_rekomb2(&Vater[i], &Vater[i], &Kind[i]);
		Kind[i].gerechnet=0;
	}

	// Summe fr Roulet Weehl bilden

	if(eltaus == 2) // Roulet Weehl
	{
		gsumme = 0;
		for(i=0;i < pop->size;i++)
		{
			gsumme += minfit/Vater[i].fitness;
		}
	}

	for(i=pop->nbest;i < pop->size;i++)	// bis alle Kinder erzeugt sind
	{
		if(eltaus == 0)	// Nur der beste darf Vater sein
		{
			indexv = 0;
			indexm = (long)(((double)rand()/RAND_MAX) *(pop->size-1));
			
		}
		if(eltaus == 1) // jeder mit jedem Zufall
		{
			indexv = (long)((double)rand()/RAND_MAX*(pop->size-1));
			indexm = (long)((double)rand()/RAND_MAX*(pop->size-1));
		}
		if(eltaus == 2) // Roulet Weehl
		{
			zufall = ((double)rand()/RAND_MAX*(gsumme));
			summe = 0;
			indexv = 0;
			for(k=0;k < pop->size;k++)
			{
				summe += minfit / Vater[k].fitness;
				if( summe >= zufall)
				{
					break;
				}
				else
				{
					indexv++;
				}
			}
			zufall = ((double)rand()/RAND_MAX*(gsumme));
			summe = 0;
			indexm = 0;
			for(k=0;k < pop->size;k++)
			{
				summe += minfit / Mutter[k].fitness;
				if( summe >= zufall)
				{
					break;
				}
				else
				{
					indexm++;
				}
			}

		}

		if(komb==0)
			do_rekomb(&Mutter[indexm], &Vater[indexv], &Kind[i]);
		if(komb==1)
			do_rekomb1(&Mutter[indexm], &Vater[indexv], &Kind[i]);
		if(komb==2)
			do_rekomb2(&Mutter[indexm], &Vater[indexv], &Kind[i]);
		Kind[i].gerechnet=0;
	}

	Kind = pop->back;    // rep mit back tauschen
	pop->back = pop->rep;
	pop->rep = Kind;

return(1);	// alles OK
}

/*---------------------------------------------------------------------------------*/

long	do_rekomb(CHROM *Mutter, CHROM *Vater, CHROM *Kind)
{
	long j,k,m;

//	if((long)((double)rand()/RAND_MAX*(2)) == 1)
	if(rand() & 0x0001)
	{
		Kind->mutprob = Vater->mutprob;
	}
	else
	{
		Kind->mutprob = Mutter->mutprob;
	}

	if(rand() & 0x0001)
	{
		Kind->mutdim = Vater->mutdim;
	}
	else
	{
		Kind->mutdim = Mutter->mutdim;
	}

	if(rand() & 0x0001)
	{
		Kind->mutdimN = Vater->mutdimN;
	}
	else
	{
		Kind->mutdimN = Mutter->mutdimN;
	}

	if(rand() & 0x0001)
	{
		Kind->mutdimV = Vater->mutdimV;
	}
	else
	{
		Kind->mutdimV = Mutter->mutdimV;
	}

	if(rand() & 0x0001)
	{
		Kind->mutdimT = Vater->mutdimT;
	}
	else
	{
		Kind->mutdimT = Mutter->mutdimT;
	}


	if(rand() & 0x0001)
	{
		Kind->mutproz = Vater->mutproz;
	}
	else
	{
		Kind->mutproz = Mutter->mutproz;
	}

	if(rand() & 0x0001)
	{
		Kind->mutprozN = Vater->mutprozN;
	}
	else
	{
		Kind->mutprozN = Mutter->mutprozN;
	}

	if(rand() & 0x0001)
	{
		Kind->mutprozT = Vater->mutprozT;
	}
	else
	{
		Kind->mutprozT = Mutter->mutprozT;
	}


	if(rand() & 0x0001)
	{
		Kind->mutprozV = Vater->mutprozV;
	}
	else
	{
		Kind->mutprozV = Mutter->mutprozV;
	}




	Kind->fitness = 0;

				// gewichte
		for(k=0; k < NEURONANZ ; k++)
		{
			for(m=0; m < NEURONANZ ; m++)
			{
				if(rand() & 0x0001)
				{
					Kind->myrep->gewicht[k*NEURONANZ+m]  = Vater->myrep->gewicht[k*NEURONANZ+m];
				}
				else
				{
					Kind->myrep->gewicht[k*NEURONANZ+m]  = Mutter->myrep->gewicht[k*NEURONANZ+m];
				}
			}
		}

				// Neuronen
		for(j=0; j < NEURONANZ ; j++)
		{
			if(rand() & 0x0001)
			{
				Kind->myrep->Neuronen[j].aktiv = Vater->myrep->Neuronen[j].aktiv;
			}
			else
			{
				Kind->myrep->Neuronen[j].aktiv = Mutter->myrep->Neuronen[j].aktiv;
			}
			if(rand() & 0x0001)
			{
				Kind->myrep->Neuronen[j].offset = Vater->myrep->Neuronen[j].offset;
			}
			else
			{
				Kind->myrep->Neuronen[j].offset = Mutter->myrep->Neuronen[j].offset;									
			}
			if(rand() & 0x0001)
			{
				Kind->myrep->Neuronen[j].temp = Vater->myrep->Neuronen[j].temp;
			}
			else
			{
				Kind->myrep->Neuronen[j].temp = Mutter->myrep->Neuronen[j].temp;
			}
			Kind->myrep->Neuronen[j].output = Vater->myrep->Neuronen[j].output; // Nur bei Inputneuronen notwendig
		}
	return(1);
}

/*---------------------------------------------------------------------------------*/
long	do_rekomb1(CHROM *Mutter, CHROM *Vater, CHROM *Kind)
{
	long j,k,m;

		Kind->mutproz = (Vater->mutproz+Mutter->mutproz)/2;

		Kind->mutprozT = (Vater->mutprozT+Mutter->mutprozT)/2;

		Kind->mutprozN = (Vater->mutprozN+Mutter->mutprozN)/2;

		Kind->mutprozV = (Vater->mutprozV+Mutter->mutprozV)/2;

		Kind->mutprob = (Vater->mutprob+Mutter->mutprob)/2;

		Kind->mutdim = (Vater->mutdim+Mutter->mutdim)/2;

		Kind->mutdimT = (Vater->mutdimT+Mutter->mutdimT)/2;

		Kind->mutdimN = (Vater->mutdimN+Mutter->mutdimN)/2;

		Kind->mutdimV = (Vater->mutdimV+Mutter->mutdimV)/2;

	Kind->fitness = 0;

				// gewichte

			for(k=0; k < NEURONANZ ; k++)
			{
				for(m=0; m < NEURONANZ ; m++)
				{
					Kind->myrep->gewicht[k*NEURONANZ+m]  = (Vater->myrep->gewicht[k*NEURONANZ+m]+Mutter->myrep->gewicht[k*NEURONANZ+m])/2;
				}
			}

				// Neuronen
			for(j=0; j < NEURONANZ ; j++)
			{
					Kind->myrep->Neuronen[j].aktiv = (Vater->myrep->Neuronen[j].aktiv+Mutter->myrep->Neuronen[j].aktiv)/2;

					Kind->myrep->Neuronen[j].offset = (Vater->myrep->Neuronen[j].offset+Mutter->myrep->Neuronen[j].offset)/2;

					Kind->myrep->Neuronen[j].temp = (Vater->myrep->Neuronen[j].temp+Mutter->myrep->Neuronen[j].temp)/2;
			}
return(-1);
}
/*---------------------------------------------------------------------------------*/

long	do_rekomb2(CHROM *Mutter, CHROM *Vater, CHROM *Kind)
{
	long j,k,m,a,c;

	a=(long)((double)rand()/RAND_MAX*(9+NEURONANZ*NEURONANZ+NEURONANZ));
	c=0;
	if(c<a)
	{
		Kind->mutprob = Vater->mutprob;
	}
	else
	{
		Kind->mutprob = Mutter->mutprob;
	}
	c++;
	if(c<a)
	{
		Kind->mutdim = Vater->mutdim;
	}
	else
	{
		Kind->mutdim = Mutter->mutdim;
	}
	c++;
	if(c<a)
	{
		Kind->mutdimN = Vater->mutdimN;
	}
	else
	{
		Kind->mutdimN = Mutter->mutdimN;
	}
	c++;
	if(c<a)
	{
		Kind->mutdimV = Vater->mutdimV;
	}
	else
	{
		Kind->mutdimV = Mutter->mutdimV;
	}
	c++;
	if(c<a)
	{
		Kind->mutdimT = Vater->mutdimT;
	}
	else
	{
		Kind->mutdimT = Mutter->mutdimT;
	}
	c++;
	if(c<a)
	{
		Kind->mutproz = Vater->mutproz;
	}
	else
	{
		Kind->mutproz = Mutter->mutproz;
	}
	c++;
	if(c<a)
	{
		Kind->mutprozN = Vater->mutprozN;
	}
	else
	{
		Kind->mutprozN = Mutter->mutprozN;
	}
	c++;
	if(c<a)
	{
		Kind->mutprozT = Vater->mutprozT;
	}
	else
	{
		Kind->mutprozT = Mutter->mutprozT;
	}
	c++;
	if(c<a)
	{
		Kind->mutprozV = Vater->mutprozV;
	}
	else
	{
		Kind->mutprozV = Mutter->mutprozV;
	}
	c++;



	Kind->fitness = 0;

				// gewichte
		for(k=0; k < NEURONANZ ; k++)
		{
			for(m=0; m < NEURONANZ ; m++)
			{
				if(c<a)
				{
					Kind->myrep->gewicht[k*NEURONANZ+m]  = Vater->myrep->gewicht[k*NEURONANZ+m];
				}
				else
				{
					Kind->myrep->gewicht[k*NEURONANZ+m]  = Mutter->myrep->gewicht[k*NEURONANZ+m];
				}
				c++;
			}
		}

				// Neuronen
		for(j=0; j < NEURONANZ ; j++)
		{
			if(c<a)
			{
				Kind->myrep->Neuronen[j].aktiv = Vater->myrep->Neuronen[j].aktiv;
			}
			else
			{
				Kind->myrep->Neuronen[j].aktiv = Mutter->myrep->Neuronen[j].aktiv;
			}
			c++;
			if(c<a)
			{
				Kind->myrep->Neuronen[j].offset = Vater->myrep->Neuronen[j].offset;
			}
			else
			{
				Kind->myrep->Neuronen[j].offset = Mutter->myrep->Neuronen[j].offset;									
			}
			c++;
			if(c<a)
			{
				Kind->myrep->Neuronen[j].temp = Vater->myrep->Neuronen[j].temp;
			}
			else
			{
				Kind->myrep->Neuronen[j].temp = Mutter->myrep->Neuronen[j].temp;
			}
			Kind->myrep->Neuronen[j].output = Vater->myrep->Neuronen[j].output; // Nur bei Inputneuronen notwendig
		}
	return(1);
}

/*---------------------------------------------------------------------------------*/
long Do_Qualitat(POPULATION *pop)
{
	long	i,j,k;
	CHROM		*cromo;
	double fehler;

	pop->propthread=1;	/* sage thread 2 es giebt was zu tun */
	cromo = pop->rep;
	for(i=0; i < pop->size ; i+=2)	// von 1 bis letzten Lebewesen
	{
		if(cromo->gerechnet==0)
		{
			for(fehler=0,j=LERNMUSTMAX-lernmust;j<LERNMUSTMAX;j++)		// von 1 bis letzten Lernmuster
	//		for(fehler=0,j=0;j<lernmust;j++)		// von 1 bis letzten Lernmuster
			{
				for(k=0; k<MAXINP; k++)		// von 1 bis letzten input  Muster in Inputneuron schreiben
				{
	//				 cromo->myrep->Neuronen[k].output = pop->musterI[j][k]+((double)rand()/RAND_MAX*((0.001)-(0.001))+(0.001)); // Mit Rauschen
					 cromo->myrep->Neuronen[k].output = pop->musterI[j][k];
				}
				fehler+=probagation(j,cromo,pop);
			}
			cromo->fitness=(fehler/lernmust);
			cromo->gerechnet=1;
		}
		cromo++;
		cromo++;
	}
	while(pop->propthread==1)
	{
		snooze(1);
	}
return(1);	// alles OK
}
long Do_Qualitat2(POPULATION *pop)
{
	long	i,j,k;
	CHROM		*cromo;
	double fehler;

	cromo = pop->rep;
	cromo++;
	for(i=1; i < pop->size ; i+=2)	// von 1 bis letzten Lebewesen
	{
		if(cromo->gerechnet==0)
		{
			for(fehler=0,j=LERNMUSTMAX-lernmust;j<LERNMUSTMAX;j++)		// von 1 bis letzten Lernmuster
	//		for(fehler=0,j=0;j<lernmust;j++)		// von 1 bis letzten Lernmuster
			{
				for(k=0; k<MAXINP; k++)		// von 1 bis letzten input  Muster in Inputneuron schreiben
				{
	//				 cromo->myrep->Neuronen[k].output = pop->musterI[j][k]+((double)rand()/RAND_MAX*((0.001)-(0.001))+(0.001)); // Mit Rauschen
					 cromo->myrep->Neuronen[k].output = pop->musterI[j][k];
				}
				fehler+=probagation(j,cromo,pop);
			}
			cromo->fitness=(fehler/lernmust);
			cromo->gerechnet=1;
		}
		cromo++;
		cromo++;
	}
return(1);	// alles OK
}
/*---------------------------------------------------------------------------------*/
double probagation(long p, CHROM	*rep, POPULATION *pop )
{
	long	i,j,k;
	double	sum;
	double	fehler,a;


for(k=0; k < iterat; k++)
  for(i=MAXINP ; i<NEURONANZ;i++)
  {
	sum = 0;
	if(rep->myrep->Neuronen[i].aktiv > 0)
	{
	 for(j=0;j<NEURONANZ;j++)
	 {
			sum += rep->myrep->gewicht[i*NEURONANZ+j] * rep->myrep->Neuronen[j].output;
	 }
	 sum += rep->myrep->Neuronen[i].offset;
	 rep->myrep->Neuronen[i].output = f(sum,rep->myrep->Neuronen[i].temp);
	}
	else
	{
		rep->myrep->Neuronen[i].output = 0;
	}
  }

 fehler = 0;
 for(i=NEURONANZ-MAXOUT;i<NEURONANZ;i++)
 {
	a = pop->musterO[p][i-(NEURONANZ-MAXOUT)] - rep->myrep->Neuronen[i].output;
	fehler +=a*a;
 }

 return(fehler);	// alles OK
}

/*---------------------------------------------------------------------------------*/
int comp_fkt(const void *a,const void *b)
{
	CHROM *aa,*bb;
	
	aa = (CHROM *)a;		// kranker Compiler
	bb = (CHROM *)b;
	if(aa->fitness < bb->fitness)
		return(-1);
	if(aa->fitness > bb->fitness)
		return(1);
	if(aa->fitness == bb->fitness)
		return(0);

return(-1);
}
/*---------------------------------------------------------------------------------*/
long Qualitatsauswahl(POPULATION *pop)		// Sortiert Lebewesen nach Fitness
{
	qsort(pop->rep, pop->size, (size_t) sizeof(CHROM), comp_fkt);
    return(1);	// alles OK
}
/*---------------------------------------------------------------------------------*/

float do_skal(float min , float max , float wert)
{
	float skalwert , skalierung , offset;

	skalierung = 0.8/(max - min);
	offset = 0.1-skalierung*min;
	skalwert=wert*skalierung+offset;

return(skalwert);
}
/*---------------------------------------------------------------------------------*/
float undo_skal(float min , float max , float skalwert)
{
	float wert , skalierung , offset;

	skalierung = 0.8/(max - min);
	offset = 0.1-skalierung*min;
	 wert=(skalwert-offset)/skalierung;
return(wert);
}

void Do_Popprop(POPULATION *pop)
{
	if(pop->propthread == 1)
	{
		Do_Qualitat2(pop);
		pop->propthread = 0;
	}
	else
	{
		snooze(1);
	}
}
