/*========================================================================
    Copyright (C) 1999  Ing Krippel Harald
    E-Mail: neuro.harald@surfeu.at

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

========================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define	ALMEMORY	130
 
#define TRUE	1
#define FALSE	0

// defines fr Population
#define	POPSIZE	50		// 18 Lebewesen in Population
#define	BESTN	15			// N Beste werden in die nchste Generation bernommen
#define	MAXGEN	400000		// hre auf 

#define	ANFERR	0.1		// Beginne mit Protokollfile 0,5
#define	faktor	0.9			// Error * faktor -> Protokoll
#define ENDERR	0.0001	// hre auf 0.0009
#define	ERRSTEP	50		// alle 50 Generationen wird der Error gezeichnet
/* Definitionen abhngiger Teil */


#define ANFMUST	8
#define	ADDME	0			// Protokollschwelle -> Lernmuster + ADDME



//-----------------------------------------------------------------

#define	MAXMUSTER	1000

/* Grenzwerte fr Wichtungsfaktoren */

#define Wmin	-35	// -35
#define Wmax	35	// 35
#define Wgmin	-2		//-2
#define Wgmax	2		//+2
#define	mutmin	-0.5 // -0,5
#define	mutmax	0.5  //0,5

#define f(x,temp)	(1/(1+exp(-((x)/(temp)))))
#define	rnd()	 ((double)rand()/RAND_MAX*((Wmax)-(Wmin))+Wmin)

typedef struct {
	float    aktiv;
	double	offset;
	double	temp;
	double	output;
}	NEURON;


typedef struct {
	NEURON	*Neuronen;
	double	*gewicht;
	}	GEHIRN;

/* Definitionen unabhngiger Teil */

typedef struct {
	GEHIRN	*myrep;
	long	mutprob;
	long	mutdim;
	long   mutdimN;
	long   mutdimV;
	long   mutdimT;
	double	mutproz;
	double	mutprozN;
	double  mutprozT;
	double  mutprozV;
	double	fitness;
	long	gerechnet;
	} CHROM;

typedef struct {
	long	size;
	long	Eltanz;
	long	nbest;
	long    Kinder;
	double	fitsum;
	double  invfitsum;
	double  *fitvec;
	long	generation;
	long	maxgenera;
	CHROM	*rep;
	CHROM 	*back;
	float	musterI[MAXMUSTER][200];	// Maximale anzahl der Muster fr Input
	float	musterO[MAXMUSTER][200];	// Maximale anzahl der Muster fr Output
	long	inUse;
	long	InitOK;
	long	inPause;
	long	propthread;
	} POPULATION;


extern BString path_string;
extern long aa;
extern long bb;
extern long cc;
extern long dd;
extern POPULATION	mypop;
extern double	STOPERROR;
extern long lernmust;
extern long NEURONANZ;

extern int	MAXINP;
extern int	MAXHINEU;
extern int	MAXSCHICHT;
extern int	MAXOUT;

/* Grenzwerte fr Skalierung */

extern float iskalmin;
extern float iskalmax;
extern float oskalmin;
extern float oskalmax;

extern long	LERNMUSTMAX;
extern long	TESTMUSTMAX;

float do_skal(float min , float max , float wert);
float undo_skal(float min , float max , float skalwert);
void save_daten(CHROM *cromo,char *name);
void open_daten(char *name);
long Do_Print(POPULATION *pop);
long Do_fPrint(POPULATION *pop, char *name);
long PopAlloc(POPULATION *pop);
long PopInit(POPULATION *pop);
long Do_PopMut(POPULATION *pop);
long Do_PopMut1(POPULATION *pop);
long Do_Qualitat(POPULATION *pop);
long Do_Qualitat2(POPULATION *pop);
double probagation(long p, CHROM	*rep, POPULATION *pop );
long Qualitatsauswahl(POPULATION *pop);
long Do_NeueKinder(POPULATION *pop);
long Do_Evolution(POPULATION *pop);
int comp_fkt(const void *,const void *);
long draw_net(CHROM	*gehirn);
void lade_daten(char *name);
void init_muster(POPULATION *pop);
void Do_Pause();
long	do_rekomb(CHROM *Mutter, CHROM *Vater, CHROM *Kind);
long	do_rekomb1(CHROM *Mutter, CHROM *Vater, CHROM *Kind);
long	do_rekomb2(CHROM *Mutter, CHROM *Vater, CHROM *Kind);
long Do_Print1(POPULATION *pop);
long Do_fPrint(POPULATION *pop, char *name);
void init_muster1(POPULATION *pop);
void init_muster2(POPULATION *pop);
void save_all_data(POPULATION	*mypop,char *name);
void open_alldata(POPULATION	*mypop,char *name);
void Do_Popprop(POPULATION *pop);
